// generated by Fast Light User Interface Designer (fluid) version 1.0104

#ifndef redgl_h
#define redgl_h
#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>

class Segment {
public:
  bool isTunnel;
  int cameraAngle;
  int visualization;
  float length;
  float seed[2];
  float scale;
  unsigned long fogColor;
  float fogNear,fogFar;
  unsigned int palette[256];
};
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Box.H>
Fl_Double_Window* make_box();

class Fl_Palette_Map : public Fl_Box {
public:
  Fl_Palette_Map(int x,int y,int w,int h,const char *s) ;
  void draw();
};

class Stage {
public:
  float pos[3];
  float orient[3];
  float trigger;
};

class Trigger {
public:
  char type[256];
  int segment;
  int health;
  int points;
  int bonusType;
  Stage stage[8];
  int stageCount;
};
extern Trigger trigger[256];
extern int activeTrigger;
extern int activeStage;

class Fl_StageXY : public Fl_Box {
public:
  Fl_StageXY(int x,int y,int w,int h,const char *title);
  void draw();
  int handle(int event);
};

class Fl_StageZTrigger : public Fl_Box {
public:
  Fl_StageZTrigger(int x,int y,int w,int h,const char *title);
  void draw();
  int handle(int event);
  void setView(bool showYZTrigger);
private:
  bool editZ;
public:
  bool showY;
  float scale;
  float base;
};

class EnemyModel {
public:
  char name[256];
  unsigned int explosionFirstColor;
  unsigned int explosionLastColor;
  float explosionRadius;
  float explosionHeightScale;
  float explosionDuration;
  char lockOnSound[256];
  char explodeSound[256];
};
extern Fl_Double_Window *rootWindow;
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Counter.H>
extern Fl_Counter *levelDuration;
extern Fl_Counter *levelSegments;
#include <FL/Fl_Value_Input.H>
extern Fl_Value_Input *evoDropRate;
extern Fl_Value_Input *chaosDropRate;
extern Fl_Value_Input *initialEvo;
extern Fl_Value_Input *initialChaos;
extern Fl_Counter *bpm;
#include <FL/Fl_Input.H>
extern Fl_Input *song;
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Slider.H>
extern Fl_Value_Slider *pathPosition;
#include <FL/Fl_Check_Button.H>
extern Fl_Check_Button *isTunnel;
#include <FL/Fl_Round_Button.H>
extern Fl_Round_Button *buttonFront;
extern Fl_Round_Button *buttonLeft;
extern Fl_Round_Button *buttonRight;
extern Fl_Round_Button *visWallp;
extern Fl_Round_Button *visJulia;
extern Fl_Round_Button *visPlasma;
extern Fl_Round_Button *visWallp2;
extern Fl_Round_Button *visCustom;
extern Fl_Value_Input *seedA;
extern Fl_Value_Input *seedB;
extern Fl_Value_Slider *segHeight;
extern Fl_Value_Slider *segLength;
extern Fl_Counter *fogNear;
extern Fl_Counter *fogFar;
extern Fl_Input *fogColor;
extern Fl_Palette_Map *palettePreview;
extern Fl_Box *mapPreview;
#include <FL/Fl_Roller.H>
extern Fl_Value_Slider *mapPosition;
#include <FL/Fl_Browser.H>
extern Fl_Browser *triggerList;
#include <FL/Fl_Choice.H>
extern Fl_Choice *triggerScore;
extern Fl_Choice *triggerBonus;
extern Fl_Input *triggerName;
extern Fl_Choice *triggerType;
extern Fl_Value_Slider *triggerSegment;
extern Fl_Value_Input *triggerHitPoints;
extern Fl_Value_Slider *triggerStage;
extern Fl_Value_Slider *triggerStageCount;
extern Fl_Value_Input *triggerX;
extern Fl_Value_Input *triggerY;
extern Fl_Value_Input *triggerZ;
extern Fl_Value_Input *triggerRX;
extern Fl_Value_Input *triggerRY;
extern Fl_Value_Input *triggerRZ;
extern Fl_Value_Input *triggerTrigger;
extern Fl_Roller *triggerRoller;
extern Fl_StageXY *stageXY;
extern Fl_StageZTrigger *stageYZTrigger;
extern Fl_StageZTrigger *stageXZTrigger;
#include <FL/Fl_Slider.H>
extern Fl_Slider *scrollYZTrigger;
extern Fl_Slider *scrollXZTrigger;
#include <FL/Fl_Value_Output.H>
extern Fl_Value_Output *valueYZTriggerBase;
extern Fl_Value_Output *valueYZTriggerScale;
extern Fl_Value_Output *valueXZTriggerBase;
extern Fl_Value_Output *valueXZTriggerScale;
extern Fl_Browser *enemyList;
extern Fl_Input *explosionFirstColor;
extern Fl_Input *explosionLastColor;
extern Fl_Value_Input *explosionRadius;
extern Fl_Value_Input *explosionHeight;
extern Fl_Input *soundLockOn;
extern Fl_Input *soundExplode;
extern Fl_Value_Input *explosionDuration;
extern Fl_Menu_Item menu_[];
#define undoMenuItem (menu_+8)
extern Fl_Menu_Item menu_triggerScore[];
extern Fl_Menu_Item menu_triggerBonus[];
extern Fl_Menu_Item menu_triggerType[];
extern Fl_Double_Window *aboutBox;
#include <FL/Fl_Output.H>
#include <FL/Fl_Return_Button.H>
Fl_Double_Window* make_about();
void new_level();
void open_level();
void save_level();
void saveas_level();
void quit_editor();
void load_level(const char *fname);
void save_level(const char *fname);
void load_palette();
void new_map();
void show_segment();
void hue_palette(float hue);

class Vertex3DCNP {
public:
  unsigned int color;
  float x,y,z,nx,ny,nz;
};

class Fl_Perspective_Preview : public Fl_Gl_Window {
  Vertex3DCNP *vert;
public:
  Fl_Perspective_Preview(int x,int y,int w,int h,const char *s) ;
  void draw();
  void drawTerrainGL();
  void genTerrain();
  struct Image *image;
private:
  int grid;
public:
  float theta,phi;
  int handle(int event);
  void drawActors();
  void drawActor(class AnimMesh *mesh);
  AnimMesh * findModel(const char *fname);
  struct Model *model;
private:
  int modelCount;
  unsigned int refresh;
};
void perspective_preview();
void genTerrain();
Fl_Double_Window* make_trigger_ed();
void update_stage();
void update_trigger();
void update_enemy();
void update_scale(Fl_StageZTrigger *stageZTrigger,Fl_Slider *scrollZTrigger);
int file_copy(const char *from,const char *to);
extern Fl_Double_Window *stepAndRepeat;
extern Fl_Value_Input *snrCount;
extern Fl_Value_Input *snrAngle;
extern Fl_Value_Input *snrCentreX;
extern Fl_Value_Input *snrCentreXInc;
extern Fl_Value_Input *snrCentreY;
extern Fl_Value_Input *snrCentreYInc;
extern Fl_Value_Input *snrTriggerInc;
extern Fl_Value_Input *snrZInc;
extern Fl_Value_Input *snrRXInc;
extern Fl_Value_Input *snrRYInc;
extern Fl_Value_Input *snrRZInc;
extern Fl_Output *snrConversion;
Fl_Double_Window* make_stepandrepeat();

class UndoRedo {
public:
  int type;
  int triggerId;
  int triggerIdCount;
  int stageId;
  Trigger *trigger;
  int changed;
  UndoRedo();
};
void save_undo(int urType);
void reset_undo();
void undo();
const char * undo_type();
#endif
